G5.ready(function() {

	var ctx = new G5.Scene(320, 180), bubbles = [];

	function spawn() {
		var x = G5.rand(0, 320),
		    factor = G5.rand(0.005, 0.05, true),
		    hsla = [G5.rand(0, 360), "50%", "50%", G5.rand(0, 1, true)];

		bubbles.push({
			x: x, y: 200,
			r: 1, hsla: hsla,
			factor: factor
		});
	}

	for (var i = 0; i < 200; i++) { spawn(); }

	G5.draw(function() {
		ctx.globalCompositeOperation = "source-over";
		ctx.fillStyle = "rgba(0, 0, 0, 0.9)";
		ctx.fillRect(0, 0, ctx.canvas.width, ctx.canvas.height);
		ctx.globalCompositeOperation = "lighter";

		for (var i = 0, l = bubbles.length; i < l; i++) {
			var b = bubbles[i];
			if (!b) { continue; }

			ctx.fillStyle = "hsla(" + b.hsla.join(",") + ")";
			ctx.beginPath();
			ctx.arc(b.x, b.y, b.r, Math.PI*2, 0, false);
			ctx.fill();
		}
	});

	G5.update(function(d) {
		for (var i = 0, l = bubbles.length; i < l; i++) {
			var b = bubbles[i];
			if (!b) { continue; }

			b.y -= (1+b.hsla[3])*d;
			b.r = b.hsla[3]*10;
			b.hsla[3] -= b.factor*d;

			if (b.hsla[3] <= 0.01) {
				bubbles.splice(i, 1);
				spawn();
			}
		}
	});

	G5.start();
});