G5.ready(function() {

	var ctx = new G5.Scene(320, 180),

	    player = {
	    	size: new G5.Vector2(19, 25),
	    	pos: new G5.Vector2(151, 78),

	    	// Image (c) GAME FREAK Inc.
	    	spritesheet: new G5.Spritesheet("assets/sprite_player.png", 19, 25, function() {
	    		this.addState("down", 0, 0).animate("x", 2, 7);
	    		this.addState("left", 0, 1).animate("x", 2, 7);
	    		this.addState("up", 0, 2).animate("x", 2, 7);
	    		this.addState("right", 0, 3).animate("x", 2, 7);
	    		this.setState("down", { frame: 1 });
	    	})
	    };

	G5.listen("[left][right][up][down]", function(key, e) {
		
		player.spritesheet.setState(key);
		player.dir = key;

	}, function(key, e) {
		if (player.dir == key) {
			player.spritesheet.setState(key, { frame: 1 });
			player.dir = "";
		}
	});

	G5.draw(function() {
		ctx.clearRect(0, 0, ctx.canvas.width, ctx.canvas.height);
		ctx.drawImage(player.spritesheet.getState(), Math.round(player.pos.x), Math.round(player.pos.y));
	});

	G5.update(function(d) {
		if (player.dir == "left") { player.pos.x -= 1*d; }
		else if (player.dir == "right") { player.pos.x += 1*d; }
		else if (player.dir == "up") { player.pos.y -= 1*d; }
		else if (player.dir == "down") { player.pos.y += 1*d; }
	});

	G5.start();
});